<?php
// +-----------------------------------------------------------------------+
// | Mod Name : Download_multi                                             |
// | Mod Version : 0.9-beta3                                               |
// | Mod Orignal author: Tboris                                            |
// | Mod Second author : Cestlodovic                                       |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// | Mod description :                                                     |
// | Ce module est base sur le module existant pour le telechargement,     |
// | cette version permet le telechargement sur plusieurs pages.           |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.               '                                                  |
// +-----------------------------------------------------------------------+

class DownloadMulti {
  var $plugin_name, $plugin_path, $plugin_url;
  var $my_config;
  
  function DownloadMulti($plugin_name, $plugin_path, $plugin_url) {
    // Args
    $this->plugin_name = $plugin_name;
    $this->plugin_path = $plugin_path;
    $this->plugin_url = $plugin_url;
    // handler
    $this->initialize_event_handler($plugin_name, $plugin_path, $plugin_url);
  }

  function initialize_event_handler() {
    global $user;
    $this->load_config(); // Chargement de la configuration
    $this->load_lang(); // Chargement des langues

    // Test si la variable DmGroup_id est existante
    // et si c'est pas un utilisateur guest
    // dans le cas contraire on fait une requête
    // A la base pour trouver le ou les identifiants  
    if ($user['status'] != 'guest' AND empty($user['DmGroup_id'])) {
      // Récupération du groupe utilisateur autorisé à télécharger les images
      $query = '
        SELECT group_id
        FROM '.USER_GROUP_TABLE.'
        WHERE user_id = '.$user['id'].'
      ;';
      $result = pwg_query($query);
      
      // Parcours la requête SQL
      while($row = mysql_fetch_array($result)) {
        // si l'utilisateur est dans le groupe authorisé
        // alors on affiche le formulaire
        if($row['group_id'] == $this->my_config['group_id']) {
          $user['DmGroup_id'] = $row['group_id'];
                    
          // Mise à jour du panier
          add_event_handler('loc_begin_index', array(&$this, 'DmCart'));
          
          // Ajout d'élements dans le header
          // Ne pas inclure dans les pages d'administration
          add_event_handler('loc_end_page_header', array(&$this, 'DmHeader'));
        
          // Ajout une entrée dans le menubar
          add_event_handler('blockmanager_apply', array(&$this, 'DmMenubar'));          
          add_event_handler('blockmanager_register_blocks', array(&$this, 'register_dm_menubar_blocks'));
         
          // ---- Thumbnail
          // Entrée HTML du formulaire pour la sélection des images
          add_event_handler('loc_begin_index_thumbnails', array(&$this, 'DmFormThumbnail'));
	  
          // Affichage des cases à cocher sous les vignettes
          add_event_handler('loc_index_thumbnail', array(&$this, 'DmCategoryThumbnail'), 50, 2);
      
          // Affichage du cadre en bas de thumbnail.tpl
          add_event_handler('loc_begin_index_thumbnails', array(&$this, 'DmCategoryDefault'));
                              
          if (script_basename() == 'popuphelp') {
            // ---- Aide
            add_event_handler('get_popup_help_content', array(&$this, 'get_popup_help_content'), EVENT_HANDLER_PRIORITY_NEUTRAL, 2);
          }
        }
      }
    }
    
    if (is_admin()) {
      // ---- Administration
      add_event_handler('get_admin_plugin_menu_links', array(&$this, 'plugin_admin_menu')); // Menu d'administration      
    }
  }
  
  /* this function initialize var $my_config with default values */
  function init_config() {
    $this->my_config = array();
  }
    
  //Chargement de la configuration
  function load_config() {
    $this->init_config();
    
    $query = '
      SELECT value 
      FROM '.CONFIG_TABLE.'
      WHERE param = \'downloadmulti_config\'
    ;';
    
    $result = pwg_query($query);
   
    if($result) {
      $row = mysql_fetch_row($result);
      if(is_string($row[0])) {
        $config = unserialize($row[0]);
        reset($config);
        while (list($key, $val) = each($config)) {
          $this->my_config[$key] = $val;
        }
      }
    }
  }

  // Sauvegarde de la configuration
  function save_config() {  	
    $query = '
      REPLACE INTO '.CONFIG_TABLE.' 
      VALUES(
        \'downloadmulti_config\',
        \''.serialize($this->my_config).'\',
        \'Configuration de Download Multi\')
    ;';
       
    $result = pwg_query($query);
    
    if($result) {
      return true;
    } else {
      return false;
    }
  }
  
  // Affichage du lien dans la barre
  // menu administrateur
  function plugin_admin_menu($menu) {
    array_push($menu,
      array(
        'NAME' => 'Download Multi',
        'URL' => get_admin_plugin_menu_link($this->plugin_path.'admin/admin.php')
      )
    );
    return $menu;
  }
  
  // Chargement des fichiers langues
  function load_lang() {
    load_language('plugin.lang', $this->plugin_path);
  }

  // Gestion de l'aide pour le plugin
  function get_popup_help_content($popup_help_content, $page) {
    if (in_array($page, array($this->plugin_name, 'DownloadMulti'))) {
      $help_content =
        load_language('help/'.$page.'.html', $this->plugin_path, array('return'=>true));
    } else {
      $help_content = false;
    }

    if ($help_content == false) {
      return $popup_help_content;
    } else {
      return $popup_help_content.$help_content;
    }
  }

  // Enregistrement du menu pour la gestion dans l'administration
  function register_dm_menubar_blocks($menu_ref_arr) {
    $menu = & $menu_ref_arr[0];
    if ($menu->get_id() != 'menubar')
      return;
    $menu->register_block(new RegisteredBlock('mbDownloadMulti', 'Download Multi', 'DM'));
  }

  // Chargement de fichier dans l'entête du template
  function DmHeader() {
    global $template;
    
    $DmUrlJs = get_root_url().'plugins/'.$this->plugin_name.'/include/DownloadMulti.js';
    $DmUrlCss = get_root_url().'plugins/'.$this->plugin_name.'/include/DownloadMulti.css';
    $template->append(
        'head_elements',
        '<script type="text/javascript" src="'.$DmUrlJs.'"></script>'."\n".
        "\t".'<link rel="stylesheet" type="text/css" href="'.$DmUrlCss.'">'."\n"
    );
  }
    
  // Gestion de l'affichage dans le menubar
  function DmMenuBar($menu_ref_arr) {
  	global $template;
  	
    $menu = & $menu_ref_arr[0];
    
    $template->assign('NBIMAGES', $this->DmCountCart());
    
    if (($block = $menu->get_block( 'mbDownloadMulti' )) != null) {
      $block->set_title('Download Multi');
      $block->template = $this->plugin_path.'template/DmMenu.tpl';
    }
  }
  
  // Compte le nombre d'images selectionné
  // dans le panier du visiteur
  function DmCountCart() {
	global $prefixeTable, $user, $lang;

    $query = '
      SELECT COUNT(*) AS nb_line
      FROM '.$prefixeTable.'download_multi
      WHERE id_user = '.$user['id'].'
    ;';
    $row = mysql_fetch_array(pwg_query($query));

    // Si le nombre de lignes est supérieur à 0
    // alors on affiche le message d'avertissement
    // utilisateur
	if ($row['nb_line'] > 0) {
      $nbImages = sprintf($lang['dl_message_cart'], $row['nb_line']);
    } else {
      $nbImages = $lang['dl_empty_cart'];
	}

	return $nbImages;
  }
  
  // Mise à jour du panier
  function DmCart() {
    if (isset($_POST['action'])) {
      switch($_POST['action']) {
        case 'add':
          $this->DmControle();
        break;
      }
    }  	
  }
  
  // Affiche l'entrée HTML du formulaire
  function DmFormThumbnail() {
    global $template;
    $template->concat('PLUGIN_INDEX_CONTENT_BEGIN', '<form id="dl" action="#" name="DmForm" method="post">');
  }
  
  // Affiche les cases à cocher derrière le nom de l'image
  // $row['id'] est l'identifiant de l'image
  function DmCategoryThumbnail($tpl_var, $row) {
    $tpl_var['NAME'] .= '&nbsp;<input type="checkbox" name="id_images[]" value="'.$row['id'].'">';

    return $tpl_var;    
  }
  
  // Affichage du formulaire sous les vignettes
  function DmCategoryDefault() {
    global $user, $template, $conf, $prefixeTable, $page, $lang;
   
    // Intégration du formulaire sous les images
    $template->set_filenames(
      array('DownloadMulti_category' => $this->plugin_path.'template/DmCategory.tpl')
    );
      
    // Titre du bloc en bas de la des vignettes
    $template->assign('DlMulti_TITLE', $lang['dl_title']);

    // Si la page de départ est une catégorie
    // on gère l'affichage ou non du téléchargement
    // des images hautes définitions
    if (isset($page['category']['name'])) {      
      // Sélection du répetoire de base pour la
      // catégorie en cours de visite
      // Permet de contrôler la présence du
      // répertoire pwg_high
      // si il est présent alors on affiche la
      // possibilité de télécharger les images
      // hautes définitions
      $query1 = '
        SELECT dir, id_uppercat
        FROM '.CATEGORIES_TABLE.'
        WHERE id = '.$page['category']['id'].'
      ;';

      $row1 = mysql_fetch_array(pwg_query($query1));

      $uppercat = $row1['id_uppercat'];
      $path = $row1['dir'];

      // Contrôle de l'existance et récupération
      // des informations pour la gestion des
      // haute définition dans les sous-catégories    
      while ($uppercat != '') {
        $query2 = '
          SELECT dir, id_uppercat
          FROM '.CATEGORIES_TABLE.'
          WHERE id = '.$uppercat.'
        ;';
            
        $row2 = mysql_fetch_array(pwg_query($query2));
        $uppercat = $row2['id_uppercat'];
        $path = $row2['dir'].'/'.$path;      
      }
      
      // Génération de l'url de départ
      $url = duplicate_index_URL();

      $template->assign('form',
        array(
          'INPUT_VALUE_NORMAL' => 'normal',
          'INPUT_VALUE_THUMBNAIL' => 'thumbnail'
        )
      );

      // Si il n'y a aucun images en hautes définitions
      // ou l'utilisateur n'a pas le droit aux hautes définitions
      // alors la ligne de téléchargement des hautes définitions
      // ne s'affiche pas.
      // Quand path est vide c'est une catégorie virtuelle
      // alors on affiche la possibilité de télécharger les images
      if($user['enabled_high'] == 1
         AND is_dir(PHPWG_ROOT_PATH.'/galleries/'.$path.'/pwg_high')
         OR $path == '') {

        $template->assign('high',
          array(
            'INPUT_VALUE_HIGH' => 'high',
          )
        );
      }      
    } else {
      // Si la page n'est pas une catégorie (recherche, favoris...)
      // Pour la gestion des hautes définitions
      // un seul contrôle est fait
      // si l'utilisateur a le droit ou non aux hautes définitions.

      $url = duplicate_index_url();
      
      $template->assign('form',
        array(
          'INPUT_VALUE_NORMAL' => 'normal',
          'INPUT_VALUE_THUMBNAIL' => 'thumbnail'
        )
      );

      // Si l'utilisateur a droit aux hautes définitions
      // la possibilité de télécharger les hautes définitions
      // s'affiche.
      if($user['enabled_high'] == 1) {
        $template->assign('form',
          array(
            'INPUT_VALUE_HIGH' => 'high',
          )
        );
      }
    }
    
    // Gestion du template
    $dm_html = $template->parse('DownloadMulti_category', true);
    $template->concat('PLUGIN_INDEX_CONTENT_END', $dm_html);
  }

  // Controle les valeurs envoyés par le formulaire
  // Crée les répertoires zip_archive et celui de l'utilisateur
  // si ils n'existent pas
  function DmControle() {
    global $template, $lang, $user, $errors;    
    $errors = array();
    
    if(isset($_POST['id_images'])) {
      $id_images = $_POST['id_images'];
    }
    
    if(isset($_POST['mode'])) {
      $mode = $_POST['mode'];
    }

    // Test si au moins une image à été
    // sélectionné
    if(!isset($id_images)) {
      array_push($errors, $lang['dl_choice_image']);
    }

    // Test le répertoire zip_archive
    // Si il n'existe pas le script le créé
    // Action nécessaire pour résoudre le problème de droit chez certains hébergeurs
    $dir = $this->plugin_path;
    if(!is_dir($dir.'zip_archive/')) {
      umask(0000);
      if(!mkdir($dir.'zip_archive/', 0777)) {
        array_push($errors, $lang['dl_dir_zip']);
      }
    }
    
    // Création du répertoire de l'utilisateur avec sont id user
    if(!is_dir($dir.'zip_archive/'.$user['id'])) {
      umask(0000);
      if(!mkdir($dir.'zip_archive/'.$user['id'], 0777)) {
        array_push($errors, $lang['dl_dir_zip']);
      }
    }
    clearstatcache();
    
    // Si il n'y a aucunes erreurs
    // on continue l'ajout dans la panier
    if(count($errors) == 0) {
      $this->DmAddPicture($id_images, $mode);
    }

    if(count($errors) != 0) {
      $template->assign('errors', $errors);
    }    
  }
  
  /* Ajoute les images dans le panier
  *  $id_images --> Liste des images sélectionnés
  *  $mode      --> Type d'images ajouter (thumbnail, normal, high) */
  function DmAddPicture($id_images, $mode) {
    global $conf, $user, $prefixeTable, $template, $lang, $errors;
    
    switch($mode) {
      case 'thumbnail':
        // Insertion des vignettes dans la base de données
        for($i=0;$i<count($id_images);$i++) {
          // Sélection des informations sur l'image
          $query = '
            SELECT id, name, file, path, tn_ext
            FROM '.IMAGES_TABLE.'
            WHERE id = \''.$id_images[$i].'\'
          ;';
          $row = mysql_fetch_array(pwg_query($query));

          $file = get_thumbnail_path($row); 
          
          // Contrôle si l'image est un fichier distant
          // Si c'est le cas alors un message
          // d'erreur est généré
          if(url_is_remote($file)) {
            if($row['name'] == '') {
              array_push($errors, $row['file'].$lang['dl_no_download_http']);
            } else {
              array_push($errors, $row['name'].$lang['dl_no_download_http']);
            }
          } else { 	
            // Poids de l'image
            $fic_size = filesize($file);

            $query = '
              INSERT INTO '.$prefixeTable.'download_multi (id_image, id_user, filesize, type)
              VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'t\')
              ON DUPLICATE KEY UPDATE
                id_user = \''.$user['id'].'\'
                AND id_image = \''.$id_images[$i].'\'
                AND type = \'t\'
              ;';
            $result = pwg_query($query);
          }       
        }
        
        if(count($errors) != 0) {
          $template->assign('errors', $errors);
        }                               
      break;
        
      case 'normal':
      	// Pas propre mais nécessaire pour get_image_path
      	include_once(PHPWG_ROOT_PATH.'include/functions_picture.inc.php');
      	
        // Insertion des photos normal dans la base de données
        for($i=0;$i<count($id_images);$i++) {
          // Sélection des informations sur l'image
          $query = '
            SELECT id, file, path
            FROM '.IMAGES_TABLE.'
            WHERE id = \''.$id_images[$i].'\'
          ;';
          $row = mysql_fetch_array(pwg_query($query));

          $file = get_image_path($row);
          
          // Contrôle si l'image est un fichier distant
          // Si c'est le cas alors un message
          // d'erreur est généré
          if (url_is_remote($file)) {
            if($row['name'] == '') {
              array_push($errors, $row['file'].$lang['dl_no_download_http']);
            } else {
              array_push($errors, $row['name'].$lang['dl_no_download_http']);
            }
          } else {
            // Taille de l'image
            $fic_size = filesize($file);

            $query = '
              INSERT INTO '.$prefixeTable.'download_multi (id_image, id_user, filesize, type)
              VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'n\')
              ON DUPLICATE KEY UPDATE
                id_user = \''.$user['id'].'\'
                AND id_image = \''.$id_images[$i].'\'
                AND type = \'n\'
            ;';
            $result = pwg_query($query);
          }
        }  
          
        if(count($errors) != 0) {
          $template->assign('errors', $errors);
        }                     
      break;

      case 'high':
      	// Pas propre mais nécessaire pour get_image_path
      	include_once(PHPWG_ROOT_PATH.'include/functions_picture.inc.php');
      	      	
        // Insertion des hautes définitions dans la base de données
        for($i=0;$i<count($id_images);$i++) {
          // Sélection des informations sur l'image
          $query = '
            SELECT id, name, file, path, has_high
            FROM '.IMAGES_TABLE.'
            WHERE id = \''.$id_images[$i].'\'
          ;';
          $row = mysql_fetch_array(pwg_query($query));

          $file = get_high_path($row);
                    
          // Si une image sélectionné ne possède pas
          // de version haute définition alors
          // on renseigne le tableau qui
          // contient la liste des images      
          if($row['has_high'] == false) {
          	if($row['name'] == '') {
          	  array_push($errors, $row['file'].$lang['dl_no_download_high']);          	
            } else {
          	  array_push($errors, $row['name'].$lang['dl_no_download_high']);
            }
          } else if (url_is_remote($file)) {
            // Contrôle si l'image est un fichier distant
            // Si c'est le cas alors un message
            // d'erreur est généré
            if($row['name'] == '') {
              array_push($errors, $row['file'].$lang['dl_no_download_http']);
            } else {
              array_push($errors, $row['name'].$lang['dl_no_download_http']);
            }
          } else {            
            // contrôle si le fichier existe, dans le cas contraire
            // rien n'est inséré et le traitement continue sur les images suivantes.
            if(file_exists($file)) {
              // Taille de l'image
              $fic_size = filesize($file);
  
              $query = '
                INSERT INTO '.$prefixeTable.'download_multi (id_image, id_user, filesize, type)
                VALUES (\''.$id_images[$i].'\', \''.$user['id'].'\', \''.$fic_size.'\', \'h\')
                ON DUPLICATE KEY UPDATE
                  id_user = \''.$user['id'].'\'
                  AND id_image = \''.$id_images[$i].'\'
                AND type = \'h\'
              ;';
              $result = pwg_query($query);
            }
          }         
        }         
      break;
    }
  }
  
  /* Préfix des fichiers zip générés
  * Si l'utilisateur vient de la page thumbnail
  * il lui est demander de saisir un nom pour
  * la génération des fichiers zip */
  function DmPanierPrefixZip() {
    global $template;

    $template->assign('prefix',
      array(
        'VALUE' => $this->my_config['prefix'],
        'F_ACTION' => 'DmPanier.php?DmAction=genfic',
      )
    );
  }

  /* Si la page est rechargé par le bouton "Supprimer"
  * du formulaire il ne faut pas recréer les fichiers */
  function DmPanierGenZip($prefix) {
    global $prefixeTable, $user, $conf, $template, $lang;

    $errors = array();

    if(preg_match('/[^a-z0-9\-_]/', $prefix)) {
      array_push($errors, $lang['dl_no_prefix']);
    } else {    
      // Sélection des photos par rapport à l'id utilisateur
      $query = '
          SELECT '.$prefixeTable.'download_multi.id_image, '.$prefixeTable.'download_multi.filesize, '.$prefixeTable.'download_multi.type,
          '.IMAGES_TABLE.'.file, '.IMAGES_TABLE.'.path, '.IMAGES_TABLE.'.tn_ext
          FROM '.$prefixeTable.'download_multi
          INNER JOIN '.IMAGES_TABLE.'
          ON '.IMAGES_TABLE.'.id = '.$prefixeTable.'download_multi.id_image
          WHERE id_user = '.$user['id'].'
      ;';

      $result = pwg_query($query);
      $nbresult = mysql_num_rows($result);
      
      // Si le nombre d'enregistrement est inférieur à 
      // alors il n'y a pas de fichier proposé au téléchargement
      if ($nbresult == 0) {
        array_push($errors, $lang['dl_no_file']);
      } else {
      	// Découpage pour la création
        // de la barre de progression
        $indice = floor(100 / $nbresult);
        $indices = 0;
        
      	$template->set_filenames(
          array('DownloadMulti_waiting' => $this->plugin_path.'/template/DmWaiting.tpl')
        );     
            
        $template->assign('waiting', $indices);
            
        $fichiers = array();
        $i = 0;
               
        while ($row = mysql_fetch_array($result)) {
          $ficdir = PHPWG_ROOT_PATH.dirname($row['path']);

          if($row['type'] == 't') {
            $namefile = explode('.', $row['file']);
            $fichiers[$i]['nom'] = $ficdir.'/thumbnail/'.$conf['prefix_thumbnail'].$namefile[0].'.'.$row['tn_ext'];
            $fichiers[$i]['path'] = $ficdir.'/thumbnail/'.$conf['prefix_thumbnail'].$namefile[0].'.'.$row['tn_ext'];
            $fichiers[$i]['poids'] = $row['filesize'];
            $i++;
          }
        
          if($row['type'] == 'n') {
            $fichiers[$i]['nom'] = $ficdir.'/'.$row['file'];
            $fichiers[$i]['path'] = $ficdir.'/'.$row['file'];
            $fichiers[$i]['poids'] = $row['filesize'];
            $i++;          
          }
        
          if($row['type'] == 'h') {
            $fichiers[$i]['nom'] = $ficdir.'/pwg_high/'.$row['file'];
            $fichiers[$i]['path'] = $ficdir.'/pwg_high/'.$row['file'];
            $fichiers[$i]['poids'] = $row['filesize'];
            $i++;          
          }                    
        }

        $fic_size = 0;
                        
        if(class_exists('zipArchive')) {
          // Création de la 1ere archive
          $this->DmCreateZip($prefix);
          
          foreach($fichiers as $cle => $file) {
          	$indices = $indice + $indices;
            // Contrôle la taille de l'archive
            // si elle est inférieur à la configuration
            // la boucle continue d'ajouter des fichiers
            if ($file['poids'] >= $this->my_config['archive_size']) {
              $this->DmAddZip($file['nom'], $file['path']);
              $this->DmCloseZip();

              $this->DmCreateZip($prefix);
              $fic_size = 0;
            } else if($fic_size <= $this->my_config['archive_size']) {
              $this->DmAddZip($file['nom'], $file['path']);
            } else {
              // si la taille est supérieur à la configuration
              // alors l'archive précédente est fermé
              // et une nouvelle est créé
              $this->DmCloseZip();
              $this->DmCreateZip($prefix);
              $this->DmAddZip($file['nom'], $file['path']);
              $fic_size = 0;
            }
            $fic_size = $file['poids'] + $fic_size;           
            
            $template->assign('waiting', $indices);
            $dm_html = $template->pparse('DownloadMulti_waiting');
            $template->concat('PLUGIN_INDEX_PANIER_BEFORE', $dm_html);
            echo '&nbsp;';
            ob_flush();
            flush();
            ob_flush();
            flush();
          }

          $this->DmCloseZip();
        } else {
          require_once $this->plugin_path.'include/pclzip.lib.php';
        
          $nbfic = count($fichiers);
          $i = 0;
          $fic_size = 0;
          $fic = '';
          $controle = FALSE;
        
          foreach($fichiers as $cle => $file) {
          	$indices = $indice + $indices;
            if ($file['poids'] >= $this->my_config['archive_size']) {
              $controle = FALSE;
              $this->DmPclZipCreateZip($prefix);
              $this->DmPclZipAddZip($file['path']);
            } else { 
              $fic[] = $file['path'];
              $fic_size = $file['poids'] + $fic_size;
              $controle = FALSE;
            }
          
            if ($fic_size >= $this->my_config['archive_size']) {
              $controle = TRUE;
            }
          
            $i++;
            if ($controle == TRUE OR $i == $nbfic) {
              $this->DmPclZipCreateZip($prefix);
              $this->DmPclZipAddZip($fic);
              $fic = '';
              $fic_size = 0;
              $controle = FALSE;
            }
            $template->assign('waiting', $indices);
            $dm_html = $template->pparse('DownloadMulti_waiting');
            $template->concat('PLUGIN_INDEX_PANIER_BEFORE', $dm_html);
            echo '&nbsp;';
            ob_flush();
            flush();
            ob_flush();
            flush();
          }
        }
      }

    }  
    // Liste le répertoire de l'utlilisateur
    $this->DmPanierListeDir();
    
    if(count($errors) != 0) {
      $template->assign('errors', $errors);
      $this->DmPanierPrefixZip();
    } 
  }

  // Créé l'archive avec son nom
  // avec la lib PclZip
  function DmPclZipCreateZip($prefix) {
    global $archive, $fichier_zip;
      	
    $fichier_zip = $this->DmCreateNameZip($prefix); 
    $archive = new PclZip($fichier_zip); 
  }
  
  // Ajout des fichiers dans l'archive
  // avec la lib PclZip  
  function DmPclZipAddZip($path) {
    global $archive, $page, $errors;

    if( $this->my_config['active_comment'] )
    {
      $action = $archive->add($path,
        PCLZIP_OPT_REMOVE_PATH, '../../../galleries',
        PCLZIP_OPT_ADD_PATH, $this->my_config['prefix_dir'],
        PCLZIP_OPT_COMMENT, $this->my_config['comment']
      );
    } else {

      $action = $archive->add($path,
        PCLZIP_OPT_REMOVE_PATH, '../../../galleries',
        PCLZIP_OPT_ADD_PATH, $this->my_config['prefix_dir']
      );
    }
          
    if ($action  == 0) {
      array_push($errors, $lang['dl_no_file']);
      $template->assign('errors', $errors);
    }
  }
  
  // Génération du nom de fichier zip
  function DmCreateNameZip($prefix) {
    global $user;
    $dir_zip = $this->plugin_path.'zip_archive/'.$user['id'].'/';
    
    $id_file = rand(1, 2000);
    $nom_fichier = $prefix.$id_file.'.zip'; // nom du fichier zip
    $fichier_zip = $dir_zip.$nom_fichier; // chemin d'accès au fichier zip
    
    return $fichier_zip;
  }
   
  // Création de l'instance zip
  // et création de l'archive avec la class zipArchive
  function DmCreateZip($prefix) {
    global $zip;
    
    $fichier_zip = $this->DmCreateNameZip($prefix);
    $zip = new ZipArchive();
    $zip->open($fichier_zip, ZIPARCHIVE::CREATE);
  }
  
  // Ajout des fichiers dans l'archive
  // avec la class zipArchive
  function DmAddZip($file, $path) {
    global $zip;
    $file = str_replace('./galleries/', '', $file);
    $zip->addFile($path, $this->my_config['prefix_dir'].'/'.$file); 
      
    if($this->my_config['active_comment']) {
      $zip->setArchiveComment($this->my_config['comment']);
    }
  }
  
  // Fermeture de l'archive
  // avec la class zipArchive
  function DmCloseZip() {
    global $zip;
    $zip->close();
  }
   
  /* Liste le répertoire utilisateur */
  function DmPanierListeDir() {
    global $user, $template, $lang, $errors;
    $dir_zip = $this->plugin_path.'zip_archive/'.$user['id'].'/';

    $errors = array();
    
    $dir = opendir($dir_zip);
    while($file = readdir($dir)) {
      if(!is_file($file) && $file != '.' && $file != '..')  {
        $tab_file[] = array('file' => $file, 'date' => filemtime($dir_zip.$file));
      }
    }
    
    closedir($dir);
    clearstatcache();    

    if (isset($tab_file)) {
      $template->assign(                  
        array(
          'F_ACTION' => 'DmPanier.php?DmAction=del'
        )
      );

      // Obtient une liste de colonnes
      foreach ($tab_file as $key => $row) {
        $file[$key]  = $row['file'];
        $date[$key] = $row['date'];
      }

      // Tri les données par volume décroissant, edition croissant
      // Ajoute $data en tant que dernier paramêtre, pour trier par la clé commune
      array_multisort($file, SORT_ASC, $date, SORT_DESC, $tab_file);

      foreach($tab_file as $elem) {
        $tpl_var = 
          array(
            'FIC_CHEMIN' => $this->plugin_url.'plugins/'.$this->plugin_name.'/zip_archive/'.$user['id'].'/',
            'FIC_NAME' => $elem['file'],
            'FIC_DATE' => $this->DmPanierDd($elem['date'])
        );
        
        $template->append('telechargements', $tpl_var);
      }
    } else {
      array_push($errors, $lang['dl_no_file']);
      $template->assign('errors', $errors);
    }    
  }

  // Vide le panier en cours
  function DmPanierDelete() {
    global $user, $prefixeTable, $page;
    // Suppression des images sélectionné dans une précédente session
    $query = '
      DELETE FROM '.$prefixeTable.'download_multi
      WHERE id_user = \''.$user['id'].'\'
    ;';
    $result = pwg_query($query);

    // Optimisation de la table pour éviter la fragmentation
    // après suppression d'enregistrements
    $query = '
      OPTIMIZE TABLE '.$prefixeTable.'download_multi
    ;';
    $result = pwg_query($query);
    
    redirect(duplicate_index_url());
  }
  
  /* Suppression des fichiers dans le
  *  répertoire utilisateur
  *  $fic --> liste des fichiers  */
  function DmPanierDelUserDir($fic) {
    global $user, $prefixeTable;
    if (isset($fic)) {
      $dir_zip = $this->plugin_path.'zip_archive/'.$user['id'].'/'; 
      foreach($fic as $file) {   
        unlink($dir_zip.$file);
      }
      clearstatcache();
    }
  } 

  /* Renvoie la date */
  function DmPanierDd($date) {
    return date("d/m/Y H:i:s", $date);
  }
/* ------- Fin de la page DmPanier.php ------ */

/* ------- Section pour le fichier DmPreview.php ------ */
  /* Affiche la liste des images */
  function DmPreviewList() {
    global $prefixeTable, $user, $template, $conf, $lang, $errors;
    
    $errors = array();
    
    $query = '
      SELECT *
      FROM '.$prefixeTable.'download_multi
      INNER JOIN '.IMAGES_TABLE.'
      ON '.IMAGES_TABLE.'.id = '.$prefixeTable.'download_multi.id_image
      WHERE id_user = '.$user['id'].'
    ;';
    $result = pwg_query($query);   
    
    // Si il n'y a pas d'enregistrement
    // Affiche le message 'panier vide'
    if (mysql_num_rows($result) == 0) {
      array_push($errors, $lang['dl_empty_cart']);
      $template->assign('errors', $errors);
    } else {
      while ($row = mysql_fetch_array($result)) {
        
        $type = $row['type'];                
        switch ($type) {
          case 't':
            $txt_type = $lang['dl_type_thumbnail'];
            $img_type = 'page_white_world.png';
          break;
          case 'n':
            $txt_type = $lang['dl_type_normal'];
            $img_type = 'page_white_picture.png';
          break;
          case 'h':
            $txt_type = $lang['dl_type_high'];
            $img_type = 'page_white_camera.png';
          break;
        }

        $url = duplicate_picture_url(
          array(
            'image_id' => $row['id'],
            'image_file' => $row['file']
          ),
          array('start')
        );

        $thumbnail_url = get_thumbnail_url($row);
        
        $tpl_var = 
          array(
            'F_ID_IMAGE' => $row['id_image'],
            'F_TYPE' => $type,
            'NAME' => get_thumbnail_title($row),
            'TYPE' => $txt_type,
            'IMG' => $img_type,
            'URL' => $url,
            'TN_SRC' => $thumbnail_url
          );
        $template->append('thumbnails', $tpl_var);
      }
    }
  }
   
  /* Supprime une image
  * id_image -> identifiant de l'image
  * type -> type de l'image */
  function DmPreviewDel($id_image, $type) {
    global $prefixeTable;
    // Suppression d'une image par rapport à sont id
    $query = '
      DELETE FROM '.$prefixeTable.'download_multi
      WHERE id_image = \''.$id_image.'\'
      AND type = \''.$type.'\'
    ;';
    $result = pwg_query($query);

    // Optimisation de la table pour éviter la fragmentation
    // après suppression d'enregistrements
    $query = '
      OPTIMIZE TABLE '.$prefixeTable.'download_multi
    ;';

    $result = pwg_query($query);
  }
/* ------- Fin de la page DmPreview.php ------ */

/* ------- Administration ------- */
  // Affiche une liste de groupe
  function DmSelectGroup($DmGroupId) {
    global $template, $prefixeTable;
    $selected = '';

    $query = 'SELECT * FROM '.$prefixeTable.'groups;';
    $result = pwg_query($query);
    while ($row = mysql_fetch_array($result)) {
      // Si l'identifiant envoyé par le formulaire
      // ou celui déjà enregistré dans la configuration
      // est celui récupéré en base alors
      // la valeur est sélectionné pour le formulaire
      if ($DmGroupId == $row['id'] OR $this->my_config['group_id'] == $row['id']) {
        $selected = ' selected="selected"';
      }
      
      $options[$row['id']] = $row['name'];
      if ($this->my_config['group_id'] == $row['id']) {
        $selected = $row['id'];   
      }
    }
    
    $template->assign('downloadmulti_group_id', array(
      'OPTIONS' => $options,
      'SELECTED' => $selected));
    $selected = '';    
  }
  
  function DmServeurConfiguration() {
    global $template;
    
    if(class_exists('zipArchive')) {
      $template->assign(
          'DmServeurConfiguration',
            array(
              'ZIP' => 'zipArchive',
              'PHP_VERSION' => PHP_VERSION,
            )
          );  
    } else {
      $template->assign(
          'DmServeurConfiguration',
            array(
              'ZIP' => 'PclZip',
              'PHP_VERSION' => PHP_VERSION,
            )
          );  
    }
  }
}
?>
